(define-module (ordo cli run)
  #:use-module (config)
  #:use-module (config api)
  #:use-module (srfi srfi-1)
  #:export (config handler))

(define (valid-tags? x)
  (or (null? x)
      (and (list? x) (every keyword? x))))

(define (parse-tags x)
  (map (compose symbol->keyword string->symbol)
       (if (list? x) x (list x))))

(define config
  (configuration
   (name 'run)
   (wanted '((keywords . (log-level)) directory))
   (keywords
    (list
     (setting
      (name 'inventory)
      (default "inventory.scm")
      (example "examples/inventory.scm")
      (handler identity)
      (test file-exists?)
      (synopsis "Inventory file"))
     (switch
      (name 'tag)
      (default (list))
      (test valid-tags?)
      (handler parse-tags)
      (merge-strategy cons)
      (synopsis "Limit operations to specified tag(s)"))))
   (arguments
    (list
     (argument
      (name 'playbook)
      (handler identity)
      (test file-exists?))))
   (synopsis "Run a playbook")))

(define (handler options)
  (format #t "run:handler log-level=~a inventory=~a tags=~a playbook=~a~%"
          (option-ref options 'log-level)
          (option-ref options 'inventory)
          (option-ref options 'tag)
          (option-ref options '(playbook))))
